// scanline_flat.s
//
// Straight conversion of the PC's assembly flat texmap drawer
// Done by Peter Hawkins(dph-man@iname.com)

.file "scanline_flat.s"

.text
  .align 4
  .globl asm_tmap_scanline_flat
    .type asm_tmap_scanline_flat,@function

  asm_tmap_scanline_flat:
  pusha
  movl fx_y,%eax
  cmpl window_bottom,%eax
  ja none_to_do
  
  imull bytes_per_row
  movl %eax,%edi
  movl fx_xleft,%eax
  testl %eax,%eax
  jns eax_ok
  xorl %eax,%eax
eax_ok:
  addl %eax,%edi
  addl write_buffer,%edi
  
  movl fx_xright,%eax
  cmpl window_right,%eax
  jl eax_ok1
  movl window_right,%eax
eax_ok1:
  cmpl window_left,%eax
  jg eax_ok2
  movl window_left,%eax
eax_ok2:
  movl fx_xleft,%ebx
  subl %ebx,%eax
  js none_to_do
  cmpl window_width,%eax
  jbe ok_to_do
  movl window_width,%eax
  decl %eax
ok_to_do:
  movl %eax,%ecx
  cmpl $0,(tmap_flat_cthru_table)
  jne do_flat_cthru
  
  movb tmap_flat_color,%al
  incl %ecx
  testl $1,%edi
  je edi_even
  movb %al,(%edi)
  incl %edi
  decl %ecx
  jz none_to_do
edi_even:
  je no_full_words
  movb %al,%ah
  rep
  stosw
no_full_words:
  adcl %ecx,%ecx
  rep
  stosb
  popa
  ret
do_flat_cthru:
  movl tmap_flat_cthru_table,%esi
  xorl %eax,%eax
  cmpl $0,%ecx
  je none_to_do
flat_cthru_loop:
  movb (%edi),%al
  movb (%eax,%esi),%al
  movb %al,(%edi)
  incl %edi
  decl %ecx
  jnz flat_cthru_loop
none_to_do:
  popa
  ret
